Subject: Re: bug#33870: 27.0.50; xref-goto-xref not configurable

From: Juri Linkov <[email-masked]>
Date: Mon, 07 Jan 2019 01:48:35 +0200

>> display-buffer--maybe-at-bottom can be renamed to
>> display-buffer-maybe-at-bottom without a deprecation alias
>> because it was added in Emacs 27.
>
> The 'display-buffer--maybe-' functions are macros in disguise invented
> by Chong to simplify coding the rest.  Unless we can't avoid it, I
> would not make them public because then we would have to (1) document
> them,

Yes, they are like macros, and this is what makes them useful for public use.

> (2) explain the semantics of the "maybe" and

The semantics is that they do what the default actions do
plus something specific.  Maybe then move the default part
from their body to some other fallback layer?  Then just use e.g.
display-buffer-at-bottom, without the -maybe part.
Or maybe use an alist for that, something like

  ((maybe-try . default-actions))

> (3) justify why the remaining 'display-buffer--maybe-' functions are
> not public.

I don't see any justification.

> Also note that 'display-buffer' resizes a window iff that window is
> new or always has shown the buffer to display before.
>
> There's one thing about 'display-buffer-at-bottom' that stupefies me:
> Here
>
> 	     (let (split-width-threshold)
> 	       (setq window (window--try-to-split-window bottom-window alist)))
>
> we bind ‘split-width-threshold’ so we can split the bottom window into
> two side by side windows.  I recently found a branch of mine where I
> bind 'split-height-threshold' to nil instead and now cannot remember
> what we really wanted - split that window horizontally or vertically.
> Can you?  In either case feel free to change that to what you consider
> the more appropriate binding - maybe even binding both.

It seems this code has no effect, it's never used.  Could you suggest
such window configuration to test that would call it?

There is another problem: in two small vertically split windows
'display-buffer-at-bottom' sometimes displays the buffer in the
upper window.